/*
    Watch Dog Adapter Test Program ---------------- DECISION Taiwan

    This is a sample C program to control WatchDog Adapter. You can
    Borland C, MicroSoft C ... to compiler it. When you execute this
    program, Watchdog Adapter is enabled. You have to press anykey
    to refresh the watchdog or system will be reboot !!!
    If you want to quit test press Q to exit.
*/
#define  INCL_BASE
#define  INCL_DOSDEVICES
#define  INCL_DOSFILEMGR
#define  INCL_DOSDEVIOCTL
#define  INCL_DOSPROCESS

#include <os2.h>
#include <bsedos.h>
#include <stdio.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <limits.h>
#include <ctype.h>
#include <sys\stat.h>
#include <mem.h>
#include <dos.h>
#include <time.h>
#include <math.h>

void watchdog(int *);             // watchdog device open
void disable_watchdog(int);       // disable watchdog device
void watchdog_refresh(int);       // enable or refresh watchdog
void watchdog_control(int, int);  // send command to remote

void main(void)
{
    int      WdgFid=0;
    int      DoWork=1;
    clrscr();
    window(0,0,80,24);
    printf("Input the Command : ( [Q]uit to Exit ) \n");
    printf("   WatchDog [E]nable [D]isable [R]efresh\n");
    printf("   Remote Power Control of[F]   o[N]\n");
    while ( DoWork ) {
	if ( kbhit() ) {
	    switch (getch()) {
		case ('Q'):
		case ('q'): DoWork=0; break;
		case ('E'):
		case ('e'): if ( WdgFid<=0 ) watchdog(&WdgFid);
			    if ( WdgFid<=0 ) {
				   printf("Watchdog open error \n");
			    } else printf("Watchdog is Enabled \n");
			    break;
		case ('R'):
		case ('r'): watchdog_refresh(WdgFid); break;
		case ('F'):
		case ('f'): watchdog_control(WdgFid, 1); break;
		case ('D'):
		case ('d'): disable_watchdog(WdgFid); WdgFid=0; break;
		case ('N'):
		case ('n'): watchdog_control(WdgFid, 0); break;
	    }
	    gotoxy(1,5);
	    printf("                           ");
	    gotoxy(1,4);
	}
    }
    if ( WdgFid > 0 ) disable_watchdog(WdgFid);
}

void watchdog(int *Fid)
{
    char DataByte;
    *Fid=open("$WdgDev$", O_RDWR);
    if ( *Fid > 0 ) {
	if ( read(*Fid, &DataByte, 1) != 1 )
	     printf("Can not enable watchdog        \n");
    } else printf("Can not open watchdog      \n");
}

void watchdog_refresh(int Fid)
{
    char DataByte;
    if ( Fid <= 0 ) return;
    if ( read(Fid, &DataByte, 1) != 1 )
	 printf("Can not refresh watchdog      \n");
    else printf("Refresh Watchdog              \n");
}

void disable_watchdog(int Fid)
{
     printf("disable watchdog              \n");
     if ( Fid <= 0 ) return;
     close(Fid);
}

void watchdog_control(int Fid, int Value)
{
    char DataByte = (char)Value;
    if ( Fid <= 0 ) return;
    if ( write(Fid, &DataByte, 1) != 1 )
	 printf("Can not control remote power  \n");
    else printf("Remote Command was sent       \n");
}

